#ifndef SHM_OUT_PORT_HPP
#define SHM_OUT_PORT_HPP

#include <boost/interprocess/managed_shared_memory.hpp>
#include <rtm/DataFlowComponentBase.h>
#include <shmport/ShmPortSVC_impl.h>

template<typename T> class ShmBuffer;

template<typename T>
class ShmOutPort 
{
public:
  ShmOutPort(const char *portName, size_t segmentSize = ShmOutPort<T>::DEFAULT_SEGMENT_SIZE);
  ~ShmOutPort();
  virtual void attachTo(RTC::DataFlowComponentBase& rtc);
  virtual void write(const T& value);
  
private:
  std::string m_name;
  std::string m_shmSegmentID;
  std::string m_shmInstanceID;
  boost::interprocess::managed_shared_memory m_shmSegment;
  ShmBuffer<T> *m_shmBuffer;
  RTC::CorbaPort m_servicePort;
  ShmPortSVC_impl m_provider;
  static const size_t DEFAULT_SEGMENT_SIZE;
};

#include "ShmOutPort_primitive.hpp"
#endif // SHM_OUT_PORT_HPP
