#include <shmport/ShmSchedInPort.hpp>
#include <iostream>

ShmSchedInPort::ShmSchedInPort(const char *portName) :
  m_delegate(portName, m_connectedInstanceName)
{
}

ShmSchedInPort::~ShmSchedInPort()
{
  using namespace std;
  cerr << "destructing ShmSchedInPort..." << endl;
}

void ShmSchedInPort::attachTo(RTC::DataFlowComponentBase& rtc)
{
  m_delegate.attachTo(rtc);
}

////////////////////////////////////////////////////////////////////////////////
bool ShmSchedInPort::isConnected()
{
  return m_delegate.isNew();
}

////////////////////////////////////////////////////////////////////////////////
/*!
 *  @brief 接続されているRTCのインスタンス名を返す。
 *
 */
const char* ShmSchedInPort::connectedInstanceName()
{
  // １回だけの送信で更新しないので readでなくpeekを使う
  m_delegate.peek(m_connectedInstanceName);
  return m_connectedInstanceName.c_str();
}
