#ifndef SHM_SCHED_IN_PORT_HPP
#define SHM_SCHED_IN_PORT_HPP

#include <shmport/ShmStringInPort.hpp>

/*!
 *  @brief スケジューラコンポーネント用ShmInPort
 *  スケジューラに取り付けるShmInPort。
 *  委譲により実装する。
 */
class ShmSchedInPort
{
public:
  ShmSchedInPort(const char *portName);
  ~ShmSchedInPort();
  void attachTo(RTC::DataFlowComponentBase& rtc);
  const char* connectedInstanceName();
  bool isConnected();
  
private:
  ShmStringInPort m_delegate;
  ShmString m_connectedInstanceName;
};


#endif // SHM_SCHED_IN_PORT_HPP

