#ifndef SHM_SCHED_OUT_PORT_HPP
#define SHM_SCHED_OUT_PORT_HPP

#include <shmport/ShmStringOutPort.hpp>

/*!
 *  @brief スケジューラコンポーネント用ShmOutPort
 *  スケジューラに接続するRTCに取り付けるShmOutPort。
 *  委譲により実装する。attachTo() 以外の操作は不要。
 */
class ShmSchedOutPort
{
public:
  ShmSchedOutPort(const char *portName);
  ~ShmSchedOutPort();
  void attachTo(RTC::DataFlowComponentBase& rtc);
  
private:
  typedef class ShmOutPort<ShmString> ShmStringOutPort;
  ShmStringOutPort m_delegate;
  ShmString m_attachedIstanceName;
};


#endif // SHM_SCHED_OUT_PORT_HPP
