// -*- C++ -*-
/*!
 * @file  CommandReceiver.cpp * @brief  * $Date$ 
 *
 * $Id$ 
 */
#include "CommandReceiver.h"

// Module specification
// <rtc-template block="module_spec">
static const char* commandreceiver_spec[] =
  {
    "implementation_id", "CommandReceiver",
    "type_name",         "CommandReceiver",
    "description",       "",
    "version",           "0.1",
    "vendor",            "TIRI",
    "category",          "Generic",
    "activity_type",     "PERIODIC",
    "kind",              "CommandReceiver",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    ""
  };
// </rtc-template>

CommandReceiver::CommandReceiver(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_in0In("in0", m_in0),
    m_in1In("in1", m_in1),
    m_in2In("in2", m_in2),
    m_in3In("in3", m_in3),
    m_modeIn("mode", m_mode),
    m_shmOutThrottle("throttle"),
    m_shmOutRoll    ("roll"),
    m_shmOutPitch   ("pitch"),
    m_shmOutYaw     ("yaw")    
    // </rtc-template>
{
  
}

CommandReceiver::~CommandReceiver()
{
}


RTC::ReturnCode_t CommandReceiver::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("in0", m_in0In);
  addInPort("in1", m_in1In);
  addInPort("in2", m_in2In);
  addInPort("in3", m_in3In);
  addInPort("mode", m_modeIn);

  // Set OutPort buffer

  // Set service provider to Ports

  // Set service consumers to Ports

  // Set CORBA Service Ports

  // </rtc-template>

  // <rtc-template block="bind_config">
  // Bind variables and configuration variable

  // </rtc-template>
  m_shmOutThrottle.attachTo(*this);
  m_shmOutRoll.attachTo(*this);    
  m_shmOutPitch.attachTo(*this);   
  m_shmOutYaw.attachTo(*this);       
  
  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t CommandReceiver::onFinalize()
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t CommandReceiver::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t CommandReceiver::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t CommandReceiver::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t CommandReceiver::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

RTC::ReturnCode_t CommandReceiver::onExecute(RTC::UniqueId ec_id)
{
  
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t CommandReceiver::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t CommandReceiver::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t CommandReceiver::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t CommandReceiver::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t CommandReceiver::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


extern "C"
{
 
  void CommandReceiverInit(RTC::Manager* manager)
  {
    coil::Properties profile(commandreceiver_spec);
    manager->registerFactory(profile,
                             RTC::Create<CommandReceiver>,
                             RTC::Delete<CommandReceiver>);
  }
  
};



