// -*- C++ -*-
/*!
 * @file  CommandReceiver.h * @brief  * @date  $Date$ 
 *
 * $Id$ 
 */
#ifndef COMMANDRECEIVER_H
#define COMMANDRECEIVER_H

#include <rtm/idl/BasicDataTypeSkel.h>
#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>

#include <shmport/ShmOutPort.hpp>

class CommandReceiver  : public RTC::DataFlowComponentBase
{
 public:
  CommandReceiver(RTC::Manager* manager);
  ~CommandReceiver();

  // The initialize action (on CREATED->ALIVE transition)
  // formaer rtc_init_entry() 
 virtual RTC::ReturnCode_t onInitialize();

  // The finalize action (on ALIVE->END transition)
  // formaer rtc_exiting_entry()
  // virtual RTC::ReturnCode_t onFinalize();

  // The startup action when ExecutionContext startup
  // former rtc_starting_entry()
  // virtual RTC::ReturnCode_t onStartup(RTC::UniqueId ec_id);

  // The shutdown action when ExecutionContext stop
  // former rtc_stopping_entry()
  // virtual RTC::ReturnCode_t onShutdown(RTC::UniqueId ec_id);

  // The activated action (Active state entry action)
  // former rtc_active_entry()
  // virtual RTC::ReturnCode_t onActivated(RTC::UniqueId ec_id);

  // The deactivated action (Active state exit action)
  // former rtc_active_exit()
  // virtual RTC::ReturnCode_t onDeactivated(RTC::UniqueId ec_id);

  // The execution action that is invoked periodically
  // former rtc_active_do()
  virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

  // The aborting action when main logic error occurred.
  // former rtc_aborting_entry()
  // virtual RTC::ReturnCode_t onAborting(RTC::UniqueId ec_id);

  // The error action in ERROR state
  // former rtc_error_do()
  // virtual RTC::ReturnCode_t onError(RTC::UniqueId ec_id);

  // The reset action that is invoked resetting
  // This is same but different the former rtc_init_entry()
  // virtual RTC::ReturnCode_t onReset(RTC::UniqueId ec_id);
  
  // The state update action that is invoked after onExecute() action
  // no corresponding operation exists in OpenRTm-aist-0.2.0
  // virtual RTC::ReturnCode_t onStateUpdate(RTC::UniqueId ec_id);

  // The action that is invoked when execution context's rate is changed
  // no corresponding operation exists in OpenRTm-aist-0.2.0
  // virtual RTC::ReturnCode_t onRateChanged(RTC::UniqueId ec_id);


 protected:
  // Configuration variable declaration
  // <rtc-template block="config_declare">
  
  // </rtc-template>

  // DataInPort declaration
  // <rtc-template block="inport_declare">
  RTC::TimedLong m_in0;
  RTC::InPort<RTC::TimedLong> m_in0In;
  RTC::TimedLong m_in1;
  RTC::InPort<RTC::TimedLong> m_in1In;
  RTC::TimedLong m_in2;
  RTC::InPort<RTC::TimedLong> m_in2In;
  RTC::TimedLong m_in3;
  RTC::InPort<RTC::TimedLong> m_in3In;
  RTC::TimedLong m_mode;
  RTC::InPort<RTC::TimedLong> m_modeIn;

  // </rtc-template>

  // DataOutPort declaration
  // <rtc-template block="outport_declare">

  // </rtc-template>

  // CORBA Port declaration
  // <rtc-template block="corbaport_declare">

  // </rtc-template>

  // Service declaration
  // <rtc-template block="service_declare">

  // </rtc-template>

  // Consumer declaration
  // <rtc-template block="consumer_declare">

  // </rtc-template>

 private:
  ShmOutPort<long> m_shmOutThrottle;
  ShmOutPort<long> m_shmOutRoll;
  ShmOutPort<long> m_shmOutPitch;
  ShmOutPort<long> m_shmOutYaw;
  long m_throttle;
  long m_roll;
  long m_pitch;
  long m_yaw;
};


extern "C"
{
  DLL_EXPORT void CommandReceiverInit(RTC::Manager* manager);
};

#endif // COMMANDRECEIVER_H

