// -*- C++ -*-
/*!
 * @file  PoseEstimator.cpp
 * @brief
 * $Date$ 
 *
 * $Id$ 
 */
#include "PoseEstimator.h"

// Module specification
// <rtc-template block="module_spec">
static const char* poseestimator_spec[] =
  {
    "implementation_id", "PoseEstimator",
    "type_name",         "PoseEstimator",
    "description",       "",
    "version",           "0.1",
    "vendor",            "TIRI",
    "category",          "Generic",
    "activity_type",     "PERIODIC",
    "kind",              "PoseEstimator",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    ""
  };
// </rtc-template>

PoseEstimator::PoseEstimator(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    // </rtc-template>
    m_shmOutRoll ("roll"),
    m_shmOutPitch("pitch"),
    m_shmOutYaw  ("yaw")
{
  
}

PoseEstimator::~PoseEstimator()
{
}


RTC::ReturnCode_t PoseEstimator::onInitialize()
{
  m_shmOutRoll .attachTo(*this);
  m_shmOutPitch.attachTo(*this);
  m_shmOutYaw  .attachTo(*this);
  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t PoseEstimator::onFinalize()
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t PoseEstimator::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t PoseEstimator::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t PoseEstimator::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t PoseEstimator::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t PoseEstimator::onExecute(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t PoseEstimator::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t PoseEstimator::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t PoseEstimator::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t PoseEstimator::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t PoseEstimator::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


extern "C"
{
 
  void PoseEstimatorInit(RTC::Manager* manager)
  {
    coil::Properties profile(poseestimator_spec);
    manager->registerFactory(profile,
                             RTC::Create<PoseEstimator>,
                             RTC::Delete<PoseEstimator>);
  }
  
};



