// -*- C++ -*-
/*!
 * @file  RotorController.cpp * @brief  * $Date$ 
 *
 * $Id$ 
 */
#include "RotorController.h"

// Module specification
// <rtc-template block="module_spec">
static const char* rotorcontroller_spec[] =
  {
    "implementation_id", "RotorController",
    "type_name",         "RotorController",
    "description",       "",
    "version",           "0.1",
    "vendor",            "TIRI",
    "category",          "Generic",
    "activity_type",     "PERIODIC",
    "kind",              "RotorController",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    ""
  };
// </rtc-template>

RotorController::RotorController(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    // </rtc-template>
    m_shmInRotVel0("rotVel0", m_rotVel0),
    m_shmInRotVel1("rotVel1", m_rotVel1),
    m_shmInRotVel2("rotVel2", m_rotVel2),
    m_shmInRotVel3("rotVel3", m_rotVel3)
{
}

RotorController::~RotorController()
{
}


RTC::ReturnCode_t RotorController::onInitialize()
{
  m_shmInRotVel0.attachTo(*this);
  m_shmInRotVel1.attachTo(*this);
  m_shmInRotVel2.attachTo(*this);
  m_shmInRotVel3.attachTo(*this);
  
  // Bind variables and configuration variable

  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t RotorController::onFinalize()
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t RotorController::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t RotorController::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t RotorController::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t RotorController::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t RotorController::onExecute(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t RotorController::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t RotorController::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t RotorController::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t RotorController::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t RotorController::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


extern "C"
{
 
  void RotorControllerInit(RTC::Manager* manager)
  {
    coil::Properties profile(rotorcontroller_spec);
    manager->registerFactory(profile,
                             RTC::Create<RotorController>,
                             RTC::Delete<RotorController>);
  }
  
};



