// -*- C++ -*-
/*!
 * @file  PrimitiveConsumer.cpp
 * @brief ShmPortService consumer
 * $Date$ 
 *
 * $Id$ 
 */
#include "PrimitiveConsumer.h"

// Module specification
static const char* primitiveconsumer_spec[] =
  {
    "implementation_id", "PrimitiveConsumer",
    "type_name",         "PrimitiveConsumer",
    "description",       "ShmPortService consumer",
    "version",           "0.1",
    "vendor",            "TIRI",
    "category",          "Generic",
    "activity_type",     "PERIODIC",
    "kind",              "PrimitiveConsumer",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    ""
  };

PrimitiveConsumer::PrimitiveConsumer(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    m_shmInPort("shmIn", m_boundVar),
    m_boundVar(0)
{
}

PrimitiveConsumer::~PrimitiveConsumer()
{
}


RTC::ReturnCode_t PrimitiveConsumer::onInitialize()
{
  m_shmInPort.attachTo(*this);
  return RTC::RTC_OK;
}

RTC::ReturnCode_t PrimitiveConsumer::onExecute(RTC::UniqueId ec_id)
{
  using namespace std;
  
  if(m_shmInPort.isNew()){
    m_shmInPort.read();
    cout << m_boundVar << endl;
  }
  
  return RTC::RTC_OK;
}

extern "C"
{
 
  void PrimitiveConsumerInit(RTC::Manager* manager)
  {
    coil::Properties profile(primitiveconsumer_spec);
    manager->registerFactory(profile,
                             RTC::Create<PrimitiveConsumer>,
                             RTC::Delete<PrimitiveConsumer>);
  }
  
};



