// -*- C++ -*-
/*!
 * @file  PrimitiveConsumer.h
 * @brief ShmPortService consumer
 * @date  $Date$ 
 *
 * $Id$ 
 */
#ifndef PRIMITIVECONSUMER_H
#define PRIMITIVECONSUMER_H

#include <rtm/idl/BasicDataTypeSkel.h>
#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <shmport/ShmInPort.hpp>


class PrimitiveConsumer  : public RTC::DataFlowComponentBase
{
public:
  PrimitiveConsumer(RTC::Manager* manager);
  ~PrimitiveConsumer();
  virtual RTC::ReturnCode_t onInitialize();
  virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);
  
private:
  ShmInPort<long> m_shmInPort;
  long m_boundVar; 
};


extern "C"
{
  DLL_EXPORT void PrimitiveConsumerInit(RTC::Manager* manager);
};

#endif // PRIMITIVECONSUMER_H

