// -*- C++ -*-
/*!
 * @file  PrimitiveProvider.h
 * @brief ShmPortService provider
 * @date  $Date$ 
 *
 * $Id$ 
 */
#ifndef PRIMITIVEPROVIDER_H
#define PRIMITIVEPROVIDER_H

#include <rtm/idl/BasicDataTypeSkel.h>
#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <shmport/ShmOutPort.hpp>

using namespace RTC;

class PrimitiveProvider  : public RTC::DataFlowComponentBase
{
public:
  PrimitiveProvider(RTC::Manager* manager);
  ~PrimitiveProvider();

  virtual RTC::ReturnCode_t onInitialize();
  virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);
private:
  ShmOutPort<long> m_shmOutPort;
  std::vector<long> m_sendingData;
};

extern "C"
{
  DLL_EXPORT void PrimitiveProviderInit(RTC::Manager* manager);
};

#endif // PRIMITIVEPROVIDER_H

